#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <time.h>
using namespace std;
typedef long long Int;

struct animal
{
    Int r,c, nc;  // nc broi vazmojni pozicii
    Int shape[11][11];
    Int cx[2600], cy[2600]; // koordinati na gornia lyav agal na k-tata pozicia, k=1,nc
    Int relx[102], rely[102]; // otnositelni koordinati na jivotnoto spriamo gornia lyav agal
    Int impactcoefficient;
    Int lowestsafetycoefficient;
    Int Numberoffilledbox;
    Int Suma[2600];
};

struct allpositions
{
    Int Sum;
    Int AnimalN;
    Int PositionN;
    double Weight;
};

struct solutions
{
    Int AnimalNum;
    Int PosN;
};

struct sortirane
{
    Int coef;
    Int nomer;
};

allpositions Positions[273000], Testpositions[2600];
animal animals[101];
sortirane Masiv[101];
solutions Solution[101], Maxsolution[101];
Int n,m,p;
Int safetytable[51][51];
Int copysafetytable[51][51];
Int numpos; //broi pozicii
Int i, j, k, l;
Int myposition, myanimal;
Int myxpos, myypos, myxrelpos, myyrelpos, numposorg;
Int mynumsol, mymaxsol;
bool myflag;
Int totalsum, maxsum;
Int glminvaluesum, glmaxvaluesum, glminvalueimpact, glmaxvalueimpact;
double MyCoef;
Int myswitch; 

Int initialclock;
double TheTime()
{
    double k=(double)( clock()-initialclock )/CLOCKS_PER_SEC;
    return k;
}


bool MyFunction(allpositions a,allpositions b)
{
    ///true - a predi b
    ///false - a sled b
    if (a.Weight>b.Weight)
    {
        return true;
    }
    else
    {
        return false;
    }
}

bool MyFunction2(sortirane a,sortirane b)
{
    if (a.coef<b.coef)
    {
        return true;
    }
    else
    {
        return false;
    }
}

void PechatResultatite()
{
    printf("%I64d\n",mymaxsol);
    for (i=1;i<=mymaxsol;i++)
    {
        j=Maxsolution[i].AnimalNum;
        myposition=Maxsolution[i].PosN;
        myxpos=animals[j].cx[myposition];
        myypos=animals[j].cy[myposition];
        printf("%I64d %I64d %I64d\n",j,myxpos,myypos);
    }
}


void CalculateRelativePossitions()
{
    Int ia, ib, ic, myind;
    for (ic=1;ic<=p;ic++)
    {
        myind=0;
        for (ia=1;ia<=animals[ic].r;ia++)
        {   
            for (ib=1;ib<=animals[ic].c;ib++)
            {
                if (animals[ic].shape[ia][ib]==1)
                {
                    myind=myind+1;
                    animals[ic].relx[myind]=ia;
                    animals[ic].rely[myind]=ib;
                }
            }
        }
        animals[ic].Numberoffilledbox=myind;
    }
}

void CalculatePossiblePositions()
{
    Int ia, ib, ic, id, myi, myj, myind;
    Int mysum;
    for (ia=1;ia<=p;ia++) //nulira broia pozicii za vsiako jivotno
    {
        animals[ia].nc=0;
    }
    // po4va da tarsi pazmojnite pozicii
    for (ia=1;ia<=n;ia++)
    {
        
        for (ib=1;ib<=m;ib++)
        {
            
            for (ic=1;ic<=p;ic++)
            {
                
                if ((ia+animals[ic].r-1>n)||(ib+animals[ic].c-1>m)) continue; 
                mysum=0;
                myind=0;
                for (id=1;id<=animals[ic].Numberoffilledbox;id++)
                {
                    myi=animals[ic].relx[id];
                    myj=animals[ic].rely[id];
                    if (safetytable[ia+myi-1][ib+myj-1]>=animals[ic].lowestsafetycoefficient)
                    {
                        myind=myind+1;
                        mysum=mysum+safetytable[ia+myi-1][ib+myj-1];
                    }
                    else
                    break;
                }
                
                if (myind==animals[ic].Numberoffilledbox)
                {
                    // namerena pozicia za ic-toto jivotno
                    animals[ic].nc=animals[ic].nc+1;
                    myi=animals[ic].nc;
                    animals[ic].cx[myi]=ia;
                    animals[ic].cy[myi]=ib;
                    animals[ic].Suma[myi]=mysum;

                }
                
            }
        }
    }
}  

bool CanJump(Int ipos, Int jpos)  // ipos e nomer jivotno, jpos e nomer pozicia
{
    Int myi, myx, myy, myrelx, myrely;
    
    myx=animals[ipos].cx[jpos];
    myy=animals[ipos].cy[jpos];
    
    for (myi=1;myi<=animals[ipos].Numberoffilledbox;myi++)
    {
        myrelx=animals[ipos].relx[myi];
        myrely=animals[ipos].rely[myi];
        if (safetytable[myx+myrelx-1][myy+myrely-1]<animals[ipos].lowestsafetycoefficient)
        {
            return false;
        }
    }
    return true;
}

void CalculateAllPositions()
{
    Int myi, myj, myk, numpos1, myelement;
 
    numpos=0;
    if (myswitch==1)
    {
        for (myj=1;myj<=p;myj++)
        {
            Masiv[myj].nomer=myj;
            Masiv[myj].coef=1;
        }
    }
    if (myswitch==2)
    {
        for (myj=1;myj<=p;myj++)
        {
            Masiv[myj].coef=animals[myj].impactcoefficient;
            Masiv[myj].nomer=myj;
            
        }
        sort(Masiv+1,Masiv+1+p,MyFunction2);
    }    
    if (myswitch==3)
    {
        for (myj=1;myj<=p;myj++)
        {
            Masiv[myj].coef=animals[myj].lowestsafetycoefficient;
            Masiv[myj].nomer=myj;
            
        }
        sort(Masiv+1,Masiv+1+p,MyFunction2);
    }    
    
    for (myk=1;myk<=p;myk++) //vsik4i jivoni edno po edno poziciite im
    {
        numpos1=0;
        myi=Masiv[myk].nomer;
        if (animals[myi].nc==0) continue;
        for (myj=1;myj<=animals[myi].nc;myj++)
        {
            numpos1=numpos1+1;
            Testpositions[numpos1].AnimalN=myi;
            Testpositions[numpos1].PositionN=myj;
            Testpositions[numpos1].Sum=animals[myi].Suma[myj];
        }
        sort(Testpositions+1,Testpositions+1+numpos1,MyFunction);
        myelement=(Int)( (double)animals[myi].nc*MyCoef );
        if (myelement==0) myelement=1;
        for (myj=1;myj<=myelement;myj++)
        {
            numpos=numpos+1;
            Positions[numpos].AnimalN=Testpositions[myj].AnimalN;
            Positions[numpos].PositionN=Testpositions[myj].PositionN;
            Positions[numpos].Sum=Testpositions[myj].Sum;
        }
    }
}


void Jumpinganimals_V2(Int mystart)
{
    Int myi, myj;
    totalsum=0;
    mynumsol=0;
    myanimal=Positions[mystart].AnimalN;
    myposition=Positions[mystart].PositionN;
    myxpos=animals[myanimal].cx[myposition];
    myypos=animals[myanimal].cy[myposition];
    for (myj=1;myj<=animals[myanimal].Numberoffilledbox;myj++)  // namaliava poletata s koeficienta za saotvetnoto jivotno.
    {
        myxrelpos=animals[myanimal].relx[myj];
        myyrelpos=animals[myanimal].rely[myj];
        totalsum=totalsum+safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1];
        safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1]=safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1]/animals[myanimal].impactcoefficient;
    }
    mynumsol=mynumsol+1;
    Solution[mynumsol].AnimalNum=myanimal;
    Solution[mynumsol].PosN=myposition;
    for (myi=1;myi<=numpos;myi++)
    {
        myanimal=Positions[myi].AnimalN;
        myposition=Positions[myi].PositionN;
        
        myflag=true; // ne e ska4alo
        // proveriava dali ve4e tova jivotno e sko4ilo predi tova
        for (myj=1;myj<=mynumsol;myj++)
        {
            if (Solution[myj].AnimalNum==myanimal)
            {
                myflag=false;  //ve4e e ska4alo
            }
        }
        if (CanJump(myanimal,myposition)&&(myflag))  //moje da ska4a i ne e ska4alo predi tova
        {
            // promenia kletkite varhu koito e padnalo
            myxpos=animals[myanimal].cx[myposition];
            myypos=animals[myanimal].cy[myposition];
            for (myj=1;myj<=animals[myanimal].Numberoffilledbox;myj++)  // namaliava poletata s koeficienta za saotvetnoto jivotno.
            {
                myxrelpos=animals[myanimal].relx[myj];
                myyrelpos=animals[myanimal].rely[myj];
                totalsum=totalsum+safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1];
                safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1]=safetytable[myxpos+myxrelpos-1][myypos+myyrelpos-1]/animals[myanimal].impactcoefficient;
            }
            mynumsol=mynumsol+1;
            Solution[mynumsol].AnimalNum=myanimal;
            Solution[mynumsol].PosN=myposition;  // do tuk dobre
        }
    }
}

int main()
{
    freopen("parash.in","r",stdin);
    freopen("parash.out","w",stdout);
    
    initialclock=clock();
    
    Int i,j, in, z, x;
    char ch;
    Int testpos;
    double drob;
    
    scanf("%I64d %I64d %I64d",&n,&m,&p);
    // vavejdane na dannite
    
    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%I64d",&safetytable[i][j]);
            copysafetytable[i][j]=safetytable[i][j];
        }
    }
    
    for (i=1;i<=p;i++)
    {
        scanf("%I64d %I64d %I64d %I64d",&animals[i].r,&animals[i].c,&animals[i].impactcoefficient,&animals[i].lowestsafetycoefficient);
        
        for (j=1;j<=animals[i].r;j++)
        {
            for (in=1;in<=animals[i].c;in++)
            {
                scanf("%c",&ch);
                
                if (ch!='0' && ch!='1')
                {
                    in--;
                    continue;
                }
                
                if (ch=='0')
                animals[i].shape[j][in]=0;
                else
                animals[i].shape[j][in]=1;
            }
        }
    }
    //na4alo    
    CalculateRelativePossitions();  /// checked
    CalculatePossiblePositions();   /// checked
//  nova logika
    MyCoef=1.0;
    myswitch=1;
    CalculateAllPositions();      /// checked
    if (numpos==0)     // ne moje nikoe jivotno da skoji
    {
        printf("%I64d\n",numpos);
        return 0;
    }
//  sortirane na poziciite
    for (i=1;i<=numpos;i++)
    {
        j=Positions[i].AnimalN;
        Positions[i].Weight=(double)Positions[i].Sum;

    }
    sort(Positions+1,Positions+1+numpos,MyFunction);  

//  po4vame da farlyame jivotni
    maxsum=-1;
    x=numpos/2;
    for (z=1;z<=numpos;z++)
    {
        if ( TheTime()>1.8 )
        {
            PechatResultatite();
            return 0;
        }
        
        drob=(double)(z-1)/(double)numpos;
        for (i=1;i<=numpos;i++)
        {
            if ( TheTime()>1.8 )
            {
                PechatResultatite();
                return 0;
            }
            j=Positions[i].AnimalN;
            Positions[i].Weight=(double)((double)Positions[i].Sum/(double)(1.0+drob*animals[j].impactcoefficient));
        }
        sort(Positions+1,Positions+1+numpos,MyFunction);  
        
        testpos=z;
        Jumpinganimals_V2(testpos);
        if (maxsum<totalsum)
        {   
            maxsum=totalsum;
            mymaxsol=mynumsol;
            for (i=1;i<=mymaxsol;i++)
            {
                Maxsolution[i]=Solution[i];
            }
        }
        
        for (i=1;i<=n;i++)
        {
            for (j=1;j<=m;j++)
            {
                safetytable[i][j]=copysafetytable[i][j];
            }
        }
    }
    // izvejda izhoda
    PechatResultatite();

}

